// +------------------------------------------------------------------+
// |                                                         Solo     |
// |                                                          2007   |
// |                Modified by Avalonish                             |
// |                            Davidke20                             |
// +------------------------------------------------------------------+
// |                                                                  |
// |   MQ's Standar MACD EA with a bit more control given to user..   |
// |            Works great with GBPUSD H4 TF                         |
// +------------------------------------------------------------------+

extern int MagicNumber=000777;
extern double Lots = 0.1;
extern double Profit = 45.0;
extern double Stop = 0.0;
extern double TrailingStop = 0.0;
extern int F_ma = 11;
extern int S_ma = 28;
extern int Signal= 9;
extern double MACDOpenLevel=3;
extern double MACDCloseLevel=2;
extern double MATrendPeriod=26;
extern string MAMode= "0=sma, 1=ema, 2=smma, 3=lwma";
extern int MA_Mode = 1; // MA method. It can be any of the Moving Average method enumeration value. 0=sma, 1=ema, 2=smma, 3=lwma
extern string MAPrice= "0=close, 1=open, 2=high, 3=low, 4=median, 5=typical, 6=weightedclose";
extern int MA_Price  = 0; // Applied price. It can be any of Applied price enumeration values. 0=close, 1=open, 2=high, 3=low, 4=median, 5=typical, 6=weightedclose
extern bool MoneyManagement = false;
extern int RiskFactor = 2.0;

double LotSize, MinLot, LotStep;

int init()
  {
   LotSize = MarketInfo(Symbol(), MODE_LOTSIZE);
   MinLot = MarketInfo(Symbol(), MODE_MINLOT);
   LotStep = MarketInfo(Symbol(), MODE_LOTSTEP);

   return(0);
  }

int deinit()
  {
//---- 
   
//----
   return(0);
  }
  
//+------------------------------------------------------------------+
//| Money Management for lot size                                    |
//+------------------------------------------------------------------+
double lot_size()
  {
   double lots;
   if (!MoneyManagement)
      return (Lots);
   lots = (AccountFreeMargin()* AccountLeverage() / LotSize) * RiskFactor/100.0;
   if (lots < MinLot) lots = MinLot;
   lots /= LotStep;
   lots = NormalizeDouble(lots, 0);
   lots *= LotStep;
   return(lots);
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   double MacdCurrent, MacdPrevious, SignalCurrent;
   double SignalPrevious, MaCurrent, MaPrevious;
   double StopLoss, TakeProfit;
    
   int cnt, total;
   total=OrdersTotal();

   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }

   MacdCurrent=iMACD(NULL,0,F_ma,S_ma,Signal,PRICE_CLOSE,MODE_MAIN,0);
   MacdPrevious=iMACD(NULL,0,F_ma,S_ma,Signal,PRICE_CLOSE,MODE_MAIN,1);
   SignalCurrent=iMACD(NULL,0,F_ma,S_ma,Signal,PRICE_CLOSE,MODE_SIGNAL,0);
   SignalPrevious=iMACD(NULL,0,F_ma,S_ma,Signal,PRICE_CLOSE,MODE_SIGNAL,1);
   MaCurrent=iMA(NULL,0,MATrendPeriod,0,MA_Mode,MA_Price,0);
   MaPrevious=iMA(NULL,0,MATrendPeriod,0,MA_Mode,MA_Price,1);

   for(cnt = 0; cnt < total; cnt++) 
     {
       OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
       if (OrderSymbol() == Symbol() && OrderMagicNumber() ==MagicNumber) // recommendation to add magic # statement here by Davidke20
     {

   if(OrderType() == OP_BUY) 
      {
       if(MacdCurrent>0 && MacdCurrent<SignalCurrent && MacdPrevious>SignalPrevious &&
        MacdCurrent>(MACDCloseLevel*Point))
      {
        OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
        return(0); // exit
      }
   if(TrailingStop > 0) 
      {
   if(Bid - OrderOpenPrice() > TrailingStop*Point) 
      {
   if(OrderStopLoss() < (Bid - TrailingStop*Point))
      {
        OrderModify(OrderTicket(), OrderOpenPrice(), 
        Bid - TrailingStop*Point, OrderTakeProfit(), 0, Blue);
        return(0);
      }
      }
      }
      }
   if(OrderType() == OP_SELL)
      {
       if(MacdCurrent<0 && MacdCurrent>SignalCurrent &&
          MacdPrevious<SignalPrevious && MathAbs(MacdCurrent)>(MACDCloseLevel*Point))
      {
         OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
         return(0); // exit
      }
       if(TrailingStop > 0) 
      {
       if(OrderOpenPrice() - Ask > TrailingStop*Point)
      {
       if(OrderStopLoss() == 0 || OrderStopLoss() > Ask + TrailingStop*Point)
      {
         OrderModify(OrderTicket(), OrderOpenPrice(), 
         Ask + TrailingStop*Point, OrderTakeProfit(), 0, Red);
         return(0);
      }           
      } 
      }
      }
      }
      return(0);
      }
// Executing a Long Position
 if(MacdCurrent<0 && MacdCurrent>SignalCurrent && MacdPrevious<SignalPrevious &&
    MathAbs(MacdCurrent)>(MACDOpenLevel*Point) && MaCurrent>MaPrevious)
   {
    if (Stop != 0) {StopLoss = Bid - Stop * Point;}
    if (Profit != 0) {TakeProfit = Ask+Profit*Point;}

      OrderSend(Symbol(),OP_BUY,lot_size(),Ask,3,StopLoss,TakeProfit,"Solo",MagicNumber,0,Green);
      return(0); 
   }

// Executing a Short Position
 if(MacdCurrent>0 && MacdCurrent<SignalCurrent && MacdPrevious>SignalPrevious && 
    MacdCurrent>(MACDOpenLevel*Point) && MaCurrent<MaPrevious)
   {  
    if (Stop != 0) {StopLoss = Ask + Stop * Point;}
    if (Profit != 0) {TakeProfit = Bid-Profit*Point;}

      OrderSend(Symbol(),OP_SELL,lot_size(),Bid,3,StopLoss,TakeProfit,"Solo",MagicNumber,0,Red);
      return(0); 
   }
  return(0); 
 }